clang 8.0.0

Enumerations | Functions
C++ AST introspection
libclang: C Interface to Clang

The routines in this group provide access information in the ASTs specific to C++ language features. More...

Collaboration diagram for C++ AST introspection:

## Enumerations
enum | CXNameRefFlags { CXNameRange_WantQualifier = 0x1, CXNameRange_WantTemplateArgs = 0x2, CXNameRange_WantSinglePiece = 0x4 }

## Functions
CINDEX_LINKAGE unsigned | clang_CXXConstructor_isConvertingConstructor (CXCursor C)
| Determine if a C++ constructor is a converting constructor. More...
CINDEX_LINKAGE unsigned | clang_CXXConstructor_isCopyConstructor (CXCursor C)
| Determine if a C++ constructor is a copy constructor. More...
CINDEX_LINKAGE unsigned | clang_CXXConstructor_isDefaultConstructor (CXCursor C)
| Determine if a C++ constructor is the default constructor. More...
CINDEX_LINKAGE unsigned | clang_CXXConstructor_isMoveConstructor (CXCursor C)
| Determine if a C++ constructor is a move constructor. More...
CINDEX_LINKAGE unsigned | clang_CXXField_isMutable (CXCursor C)
| Determine if a C++ field is declared 'mutable'. More...
CINDEX_LINKAGE unsigned | clang_CXXMethod_isDefaulted (CXCursor C)
| Determine if a C++ method is declared '= default'. More...
CINDEX_LINKAGE unsigned | clang_CXXMethod_isPureVirtual (CXCursor C)
| Determine if a C++ member function or member function template is pure virtual. More...
CINDEX_LINKAGE unsigned | clang_CXXMethod_isStatic (CXCursor C)
| Determine if a C++ member function or member function template is declared 'static'. More...
CINDEX_LINKAGE unsigned | clang_CXXMethod_isVirtual (CXCursor C)
| Determine if a C++ member function or member function template is explicitly declared 'virtual' or if it overrides a virtual method from one of the base classes. More...
CINDEX_LINKAGE unsigned | clang_CXXRecord_isAbstract (CXCursor C)
| Determine if a C++ record is abstract, i.e. More...
CINDEX_LINKAGE unsigned | clang_EnumDecl_isScoped (CXCursor C)
| Determine if an enum declaration refers to a scoped enum. More...
CINDEX_LINKAGE unsigned | clang_CXXMethod_isConst (CXCursor C)
| Determine if a C++ member function or member function template is declared 'const'. More...
CINDEX_LINKAGE enum CXCursorKind | clang_getTemplateCursorKind (CXCursor C)
| Given a cursor that represents a template, determine the cursor kind of the specializations would be generated by instantiating the template. More...
CINDEX_LINKAGE CXCursor | clang_getSpecializedCursorTemplate (CXCursor C)
| Given a cursor that may represent a specialization or instantiation of a template, retrieve the cursor that represents the template that it specializes or from which it was instantiated. More...
CINDEX_LINKAGE CXSourceRange | clang_getCursorReferenceNameRange (CXCursor C, unsigned NameFlags, unsigned PieceIndex)
| Given a cursor that references something else, return the source range covering that reference. More...

## Detailed Description

The routines in this group provide access information in the ASTs specific to C++ language features.

## Enumeration Type Documentation

## ◆ CXNameRefFlags

enum CXNameRefFlags

Enumerator
CXNameRange_WantQualifier | Include the nested-name-specifier, e.g. Foo:: in x.Foo::y, in the range.
CXNameRange_WantTemplateArgs | Include the explicit template arguments, e.g. <int> in x.f<int>, in the range.
CXNameRange_WantSinglePiece | If the name is non-contiguous, return the full spanning range. Non-contiguous names occur in Objective-C when a selector with two or more parameters is used, or in C++ when using an operator: [object doSomething:here withValue:there]; // Objective-C return some_vector[1]; // C++

Definition at line 4807 of file Index.h.

## Function Documentation

## ◆ clang_CXXConstructor_isConvertingConstructor()

CINDEX_LINKAGE unsigned clang_CXXConstructor_isConvertingConstructor | ( | CXCursor | C | ) |

Determine if a C++ constructor is a converting constructor.

## ◆ clang_CXXConstructor_isCopyConstructor()

CINDEX_LINKAGE unsigned clang_CXXConstructor_isCopyConstructor | ( | CXCursor | C | ) |

Determine if a C++ constructor is a copy constructor.

## ◆ clang_CXXConstructor_isDefaultConstructor()

CINDEX_LINKAGE unsigned clang_CXXConstructor_isDefaultConstructor | ( | CXCursor | C | ) |

Determine if a C++ constructor is the default constructor.

## ◆ clang_CXXConstructor_isMoveConstructor()

CINDEX_LINKAGE unsigned clang_CXXConstructor_isMoveConstructor | ( | CXCursor | C | ) |

Determine if a C++ constructor is a move constructor.

## ◆ clang_CXXField_isMutable()

CINDEX_LINKAGE unsigned clang_CXXField_isMutable | ( | CXCursor | C | ) |

Determine if a C++ field is declared 'mutable'.

## ◆ clang_CXXMethod_isConst()

CINDEX_LINKAGE unsigned clang_CXXMethod_isConst | ( | CXCursor | C | ) |

Determine if a C++ member function or member function template is declared 'const'.

## ◆ clang_CXXMethod_isDefaulted()

CINDEX_LINKAGE unsigned clang_CXXMethod_isDefaulted | ( | CXCursor | C | ) |

Determine if a C++ method is declared '= default'.

## ◆ clang_CXXMethod_isPureVirtual()

CINDEX_LINKAGE unsigned clang_CXXMethod_isPureVirtual | ( | CXCursor | C | ) |

Determine if a C++ member function or member function template is pure virtual.

## ◆ clang_CXXMethod_isStatic()

CINDEX_LINKAGE unsigned clang_CXXMethod_isStatic | ( | CXCursor | C | ) |

Determine if a C++ member function or member function template is declared 'static'.

## ◆ clang_CXXMethod_isVirtual()

CINDEX_LINKAGE unsigned clang_CXXMethod_isVirtual | ( | CXCursor | C | ) |

Determine if a C++ member function or member function template is explicitly declared 'virtual' or if it overrides a virtual method from one of the base classes.

## ◆ clang_CXXRecord_isAbstract()

CINDEX_LINKAGE unsigned clang_CXXRecord_isAbstract | ( | CXCursor | C | ) |

Determine if a C++ record is abstract, i.e.

whether a class or struct has a pure virtual member function.

## ◆ clang_EnumDecl_isScoped()

CINDEX_LINKAGE unsigned clang_EnumDecl_isScoped | ( | CXCursor | C | ) |

Determine if an enum declaration refers to a scoped enum.

## ◆ clang_getCursorReferenceNameRange()

CINDEX_LINKAGE CXSourceRange clang_getCursorReferenceNameRange | ( | CXCursor | C,
|  | unsigned | NameFlags,
|  | unsigned | PieceIndex
| ) |  |

Given a cursor that references something else, return the source range covering that reference.

Parameters

  C | A cursor pointing to a member reference, a declaration reference, or an operator call.
  NameFlags | A bitset with three independent flags: CXNameRange_WantQualifier, CXNameRange_WantTemplateArgs, and CXNameRange_WantSinglePiece.
  PieceIndex | For contiguous names or when passing the flag CXNameRange_WantSinglePiece, only one piece with index 0 is available. When the CXNameRange_WantSinglePiece flag is not passed for a non-contiguous names, this index can be used to retrieve the individual pieces of the name. See also CXNameRange_WantSinglePiece.

Returns
  The piece of the name pointed to by the given cursor. If there is no name, or if the PieceIndex is out-of-range, a null-cursor will be returned.

## ◆ clang_getSpecializedCursorTemplate()

CINDEX_LINKAGE CXCursor clang_getSpecializedCursorTemplate | ( | CXCursor | C | ) |

Given a cursor that may represent a specialization or instantiation of a template, retrieve the cursor that represents the template that it specializes or from which it was instantiated.

This routine determines the template involved both for explicit specializations of templates and for implicit instantiations of the template, both of which are referred to as "specializations". For a class template specialization (e.g., `std::vector<bool>`), this routine will return either the primary template (`std::vector`) or, if the specialization was instantiated from a class template partial specialization, the class template partial specialization. For a class template partial specialization and a function template specialization (including instantiations), this this routine will return the specialized template.

For members of a class template (e.g., member functions, member classes, or static data members), returns the specialized or instantiated member. Although not strictly "templates" in the C++ language, members of class templates have the same notions of specializations and instantiations that templates do, so this routine treats them similarly.

Parameters

  C | A cursor that may be a specialization of a template or a member of a template.

Returns
  If the given cursor is a specialization or instantiation of a template or a member thereof, the template or member that it specializes or from which it was instantiated. Otherwise, returns a NULL cursor.

## ◆ clang_getTemplateCursorKind()

CINDEX_LINKAGE enum CXCursorKind clang_getTemplateCursorKind | ( | CXCursor | C | ) |

Given a cursor that represents a template, determine the cursor kind of the specializations would be generated by instantiating the template.

This routine can be used to determine what flavor of function template, class template, or class template partial specialization is stored in the cursor. For example, it can describe whether a class template cursor is declared with "struct", "class" or "union".

Parameters

  C | The cursor to query. This cursor should represent a template declaration.

Returns
  The cursor kind of the specializations that would be generated by instantiating the template `C`. If `C` is not a template, returns `CXCursor_NoDeclFound`.